--- old/usr/src/cmd/boot/bootadm/bootadm_loader.c	Sat May 13 07:19:07 2017
+++ new/usr/src/cmd/boot/bootadm/bootadm_loader.c	Sat May 13 07:19:07 2017
@@ -26,6 +26,7 @@
 /*
  * Copyright 2015 Nexenta Systems, Inc. All rights reserved.
  * Copyright 2016 Toomas Soome <tsoome@me.com>
+ * Copyright 2017 RackTop Systems.
  */
 
 /*
@@ -182,7 +183,7 @@
     struct menu_lst *menu)
 {
 	struct menu_entry  *entry;
-	int i = -1;
+	int i = 0;
 	int rv;
 	be_node_list_t *be_nodes, *be_node;
 
@@ -191,23 +192,27 @@
 		return;
 
 	STAILQ_FOREACH(entry, menu, next) {
-		i++;
+		boolean_t active = B_FALSE;
+
 		for (be_node = be_nodes; be_node;
 		    be_node = be_node->be_next_node)
 			if (strcmp(be_node->be_root_ds, entry->bootfs) == 0)
-				break;
+				if (be_node->be_active_on_boot)
+					active = B_TRUE;
 
 		if (parsable)
 			(void) printf("%d;%s;%s;%s\n", i,
-			    be_node->be_active_on_boot == B_TRUE? "*" : "-",
+			    active == B_TRUE ? "*" : "-",
 			    entry->bootfs, entry->title);
 		else
 			(void) printf("%-*d %-*s %-*s %-*s\n",
 			    hdr->cols[0].width, i,
 			    hdr->cols[1].width,
-			    be_node->be_active_on_boot == B_TRUE? "*" : "-",
+			    active == B_TRUE ? "*" : "-",
 			    hdr->cols[2].width, entry->bootfs,
 			    hdr->cols[3].width, entry->title);
+
+		i++;
 	}
 	be_free_list(be_nodes);
 }
